<import resource="classpath:alfresco/templates/webscripts/org/alfresco/repository/requestutils.lib.js">
<import resource="classpath:alfresco/templates/webscripts/org/alfresco/repository/nodenameutils.lib.js">

/**
 * Creates a polling
 */
function createPolling(container)
{
   // get a unique name
   var nodeName = getUniqueChildName(container, "polling");
   pollingNode = container.createNode(nodeName, "ocm:polling", getPollingProperties());
   var tags = [];
   if (json.has("tags"))
   {
      // get the tags JSONArray and copy it into a real javascript array object
      var jstags = json.get("tags");
      for (var t = 0; t < jstags.length(); t++)
      {
         tags.push(jstags.get(t));
      }
   }
   pollingNode.tags = tags;
   pollingNode.save();

   return pollingNode;
}

/**
 * Fetches the polling properties from the json object and adds them to an array
 * using the correct property names as indexes.
 */
function getPollingProperties()
{
   var data = [];
   if (json.has("title"))
   {
     data["ocm:title"] = json.get("title");
   }
   if (json.has("description"))
   {
     data["ocm:description"] = json.get("description");
   }
   if (json.has("pollingItemType"))
   {
     data["ocm:pollingItemType"] = json.get("pollingItemType");
   }
   return data;
}

function ensureTagScope(node)
{
   if (!node.isTagScope)
   {
     node.isTagScope = true;
   }

   // also check the parent (the site!)
   if (!node.parent.isTagScope)
   {
      node.parent.isTagScope = true;
   }
}

function main()
{
   // get pollings container
   var node = getRequestNode();
   if (status.getCode() != status.STATUS_OK)
   {
      return;
   }
      
   if (!node.hasPermission("CreateChildren"))
   {
      status.code = 403;
      var mes = "Permission to create is denied";
      status.message = mes;
      model.message = mes;
      return;
   }

   ensureTagScope(node);

   var polling = createPolling(node);
   model.item = polling;    
}

main();