<import resource="classpath:alfresco/templates/webscripts/org/alfresco/repository/requestutils.lib.js">
<import resource="classpath:alfresco/templates/webscripts/org/alfresco/repository/searchutils.lib.js">
<import resource="classpath:alfresco/templates/webscripts/org/alfresco/repository/generic-paged-results.lib.js">

const DEFAULT_NUM_DAYS = 7;

function getPollingsData(node)
{
   var itm = {};
   itm.node = node;
   itm.name  = node.name || "";
   itm.title = node.properties["ocm:title"] || "";
   itm.description = node.properties["ocm:description"] || "";
   itm.pollingItemType = node.properties["ocm:pollingItemType"] || "";
   itm.createdOn = node.properties.created || "";
   itm.modifiedOn = node.properties.modified || "";
   itm.creator = people.getPerson(node.properties["cm:creator"]);
   itm.tags = node.tags;
   return itm;
}

/**
 * Fetches all pollings added to the site
 */
function getPollingsList(container, filter, tag, numdays, index, count)
{
   // query information
   var luceneQuery = " +TYPE:\"{http://www.ocopomo.eu/alfresco/model/1.0}polling\" +PATH:\"" + container.qnamePath + "/*\"";
   
   if (filter == "recent")
   {
      var fromDate = getTodayMinusXDays(DEFAULT_NUM_DAYS);
      var toDate = new Date();

      luceneQuery += getCreationDateRangeQuery(fromDate, toDate);
   }
   else if (filter == "user")
   {
      luceneQuery += " +@cm\\:creator:\"" + person.properties.userName + '"';
   }
   
   if (tag !== null)
   {
      luceneQuery += " +PATH:\"/cm:taggable/cm:" + search.ISO9075Encode(tag) + "/member\" ";
   }
   
   var sortAttribute = "@{http://www.alfresco.org/model/content/1.0}created";
   
   // get the data
   return getPagedResultsDataByLuceneQuery(container, luceneQuery, sortAttribute, false, index, count, getPollingsData);
}

function main()
{
   // get requested node
   var node = getRequestNode();
   if (status.getCode() != status.STATUS_OK)
   {
      return;
   }
   
   var pNumber = parseInt(args.page, 10);
   var pSize = parseInt(args.pageSize, 10);
   var filter = args.filter;
   var tag = (args.tag != undefined && args.tag.length > 0) ? args.tag : null;
   
   if ((pNumber === undefined) || (pSize === undefined))
   {
      model.error = "Parameters missing!";
      return;
   }
   model.pollings = node;
   model.data = getPollingsList(node,filter,tag,7,(pNumber - 1) * pSize,pSize);
}

main();