<#import "../../repository/generic-paged-results.lib.ftl" as gen>

<#macro renderPerson person fieldName>
<#escape x as jsonUtils.encodeJSONString(x)>
   "${fieldName}":
   {
   <#if person.assocs["cm:avatar"]??>
      "avatarRef": "${person.assocs["cm:avatar"][0].nodeRef?string}",
   </#if>
      "username": "${person.properties["cm:userName"]}",
      "firstName": "${person.properties["cm:firstName"]!""}",
      "lastName": "${person.properties["cm:lastName"]!""}"
   },
</#escape>
</#macro>

<#--
   This template renders a polling.
-->
<#macro pollingJSON item>
<#escape x as jsonUtils.encodeJSONString(x)>
{
   "nodeRef": "${item.node.nodeRef}",
   "name": "${item.name!''}",
   "title": "${item.title!''}",
   "description": "${item.description!''}",
   "pollingItemType": "${item.pollingItemType!''}",
   "createdOn": "${item.createdOn?string("MMM dd yyyy HH:mm:ss 'GMT'Z '('zzz')'")}",
   <#if item.creator??>
   <@renderPerson person=item.creator fieldName="author" />
   <#else>
   "author":
   {
      "username": "${item.node.properties.creator}"
   },
   </#if>
   "permissions":
   {
      "edit": ${item.node.hasPermission("Write")?string},
      "delete": ${item.node.hasPermission("Delete")?string}
   },
   "tags": [<#list item.tags as x>"${x}"<#if x_has_next>, </#if></#list>]
}
</#escape>
</#macro>

<#macro renderPollingList>
<#escape x as jsonUtils.encodeJSONString(x)>
{
   "metadata":
   {
      "pollingPermissions":
      {
         "create": "${pollings.hasPermission("CreateChildren")?string}"
      }
   },
   <@gen.pagedResults data=data ; item>
      <@pollingJSON item=item />
   </@gen.pagedResults>
}
</#escape>
</#macro>

<#macro renderPolling>
<#escape x as jsonUtils.encodeJSONString(x)>
{
   "item": <@pollingJSON item=item />
}
</#escape>
</#macro>